package edu.stanford.nlp.parser.lexparser;

import java.io.Serializable;
import java.util.Map;

/**
 * Stores the serialized material representing the grammar and lexicon of a 
 * parser, and an Options that specifies things like how unknown words were
 * handled and how distances were binned that will also be needed to parse
 * with the grammar.
 *
 * @author Dan Klein
 * @author Christopher Manning
 */
public class ParserData implements Serializable {

  Lexicon lex;
  BinaryGrammar bg;
  UnaryGrammar ug;
  DependencyGrammar dg;
  Map numbs;
  Options pt;

  public ParserData(Lexicon lex, BinaryGrammar bg, UnaryGrammar ug, DependencyGrammar dg, Map numbs, Options pt) {
    this.lex = lex;
    this.bg = bg;
    this.ug = ug;
    this.dg = dg;
    this.numbs = numbs;
    this.pt = pt;
  }

  private static final long serialVersionUID = 1;

}
