package edu.stanford.nlp.process;

import edu.stanford.nlp.ling.Document;

import java.util.ArrayList;
import java.util.List;

/**
 * Class AbstractListProcessor
 *
 * @author Teg Grenager
 */
public abstract class AbstractListProcessor implements ListProcessor, Processor {

  public Document processDocument(Document in) {
    List list = in;
    Document doc = in.blankDocument();
    doc.addAll(process(list));
    return doc;
  }

  /** Process a list of lists of tokens.
   * @param lists a List of objects of type List
   * @return a List of objects of type List, each of which has been processed.
   */
  public List processLists(List<List> lists) {
    List result = new ArrayList(lists.size());
    for (List list : lists) {
      List outList = process(list);
      result.add(outList);
    }
    return result;
  }

}
