package edu.stanford.nlp.process;

import java.util.List;

/**
 * An interface for things that operate on a List.  This is seen as
 * a lighter weight and more general interface than the Processor interface
 * for documents.
 *
 * @author Teg Grenager
 */
public interface ListProcessor {

  /**
   * Take a List (including a Sentence) of input, and return a
   * List that has been processed in some way.
   */
  public List process(List list);

}
