package edu.stanford.nlp.trees;

import java.util.List;
import java.util.ArrayList;

/**
 * A TreeTransformer that applies component TreeTransformers in order.
 * @author Galen Andrew
 */
public class CompositeTreeTransformer implements TreeTransformer {
  private List<TreeTransformer> transformers = new ArrayList<TreeTransformer>();

  public void addTransformer(TreeTransformer tt) {
    transformers.add(tt);
  }

  public Tree transformTree(Tree t) {
    for (TreeTransformer tt : transformers) {
      t = tt.transformTree(t);
    }
    return t;
  }
}
