package edu.stanford.nlp.trees.international.tuebadz;

import edu.stanford.nlp.trees.AbstractTreebankLanguagePack;

/**  Language pack for the Tuebingen Treebank of Written German (TueBa-D/Z): http://www.sfs.nphil.uni-tuebingen.de/en_tuebadz.shtml
 *
 * @author Roger Levy (rog@stanford.edu)
 */
public class TueBaDZLanguagePack extends AbstractTreebankLanguagePack {

  private static String[] tuebadzPunctTags = {"$.","$,","$-LRB"};

  private static String[] tuebadzSFPunctTags = {"$."};


  private static String[] tuebadzPunctWords = { "`", "-", ",", ";", ":", "!", "?", "/", ".", "...","'", "\"", "[", "]", "*"};

  private static String[] tuebadzSFPunctWords = {".", "!", "?"};

  public String[] punctuationTags() {
    return tuebadzPunctTags;
  }

  public String[] punctuationWords() {
    return tuebadzPunctWords;
  }

  public String[] sentenceFinalPunctuationTags() {
    return tuebadzSFPunctTags;
  }

  public String[] startSymbols() {
    return new String[] {"TOP"};
  }

  public String[] sentenceFinalPunctuationWords() {
    return tuebadzSFPunctWords;
  }

  public String treebankFileExtension() {
    return ".penn";
  }

}
