package edu.stanford.nlp.util;

import java.util.Iterator;

/**
 * Iterator with remove defined to throw UnsupportedOperationException .
 */
abstract public class AbstractIterator implements Iterator {
  abstract public boolean hasNext();

  abstract public Object next();

  /**
   * Throws an UnupportedOperationException .
   */
  public void remove() {
    throw new UnsupportedOperationException();
  }
}
