#!/bin/csh -f
#
# You need to klog before you can run this so you have AFS access!
#

set command="java -server -mx500m edu.stanford.nlp.parser.lexparser.LexicalizedParser"
set wsj=/afs/ir/data/linguistic-data/Treebank/3/parsed/mrg/wsj
set pparser=/u/nlp/data/lexparser/englishPCFG.ser.gz
set test=/u/nlp/data/lexparser/test

echo
echo "These files should have 35 sentences and 820 words each"
echo 

$command $pparser $test/test_raw.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences newline $pparser $test/test_newline.txt > test.out
echo
diff test.gold test.out
echo
$command -parseInside s $pparser $test/test_charniak.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences NEWSENTENCE $pparser $test/test_NEWSENTENCE.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences newline -tokenized -escaper edu.stanford.nlp.process.PTBEscapingProcessor $pparser $test/test_tokenized_newline.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences NEWSENTENCE -tokenized -escaper edu.stanford.nlp.process.PTBEscapingProcessor $pparser $test/test_tokenized_NEWSENTENCE.txt > test.out
echo
diff test.gold test.out
echo
$command -parseInside s -tokenized -escaper edu.stanford.nlp.process.PTBEscapingProcessor $pparser $test/test_tokenized_charniak.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences newline -tokenized $pparser $test/test_PTBtokenized_newline.txt > test.out
echo
diff test.gold test.out
echo
echo "Testing test_PTBtokenized_newline_tagged.txt"
$command -sentences newline -tokenized -tagSeparator "/" $pparser $test/test_PTBtokenized_newline_tagged.txt > test.out
echo
diff test.gold test.out
echo
$command -sentences NEWSENTENCE -tokenized $pparser $test/test_PTBtokenized_NEWSENTENCE.txt > test.out
echo
diff test.gold test.out
echo
echo "Testing test_PTBtokenized_tagged.txt (not sentence split)"
$command -tokenized -tagSeparator "/" $pparser $test/test_PTBtokenized_tagged.txt > test.out
echo
diff test.gold test.out
echo
$command -parseInside s -tokenized $pparser $test/test_PTBtokenized_charniak.txt > test.out
echo
diff test.gold test.out
echo
$command -tokenized $pparser $test/test_PTBtokenized.txt > test.out
echo
diff test.gold test.out
echo
$command -tokenized -escaper edu.stanford.nlp.process.PTBEscapingProcessor $pparser $test/test_tokenized.txt > test.out
echo
diff test.gold test.out
echo
# $command -tokenized -tagSeparator / $pparser $test/test_tagged.txt > test.out
# echo
# diff test.gold test.out
# echo
$command -sentences newline -tokenized -tagSeparator / $pparser $test/test_tokenized_newline_tagged.txt > test.out
 echo
 diff test.gold test.out
 echo
# $command -sentences newline -tokenized -tagSeparator / $pparser $test/test_newline_tagged_noescaping.txt > test.out
# echo
# diff test.gold test.out
# echo


echo
echo "These files should have 3 sentences and 28 words each"
echo 

echo "Testing test_sentence_splitting.txt"
$command $pparser $test/test_sentence_splitting.txt
$command -tokenized -tagSeparator / $pparser $test/test_sentence_splitting_tagged.txt

echo
echo "This file should have 2 sentences and 21 words."
echo 
echo "Testing test_crazy_sentences.txt"
$command -sentences '<s>' $pparser $test/test_crazy_sentences.txt


echo
echo "This file should have ? sentences and ?? words each"
echo 

$command -maxLength 60 $pparser "http://nlp.stanford.edu/projects/test_raw.html"
